/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ScheduleUtil;

import InitialSchedules.ParametersInitialSchedules;
import SchedulesRecovery.*;
/**
 *
 * @author frabe
 */
public class EmployeeCostCalculator {
    
    public static int getFullScheduleCost( boolean[][] partTimeEmployeesSchedule , boolean[][] fullTimeEmployeesSchedule, ParametersInitialSchedules myScheduleParameters) {
        return 0;
    }
    
    public static int getRecoveringActionCost (RecoveringAction action, ParametersInitialSchedules myScheduleParameters) {
        int actionCost = 0;
        if (action.getClass().getName() == "RecoveringActionPartTimeEmployee") {
            actionCost = getPartTimeEmployeeCost(action.employeeScheduleAfterRecoveringAction, myScheduleParameters) - 
                    getPartTimeEmployeeCost(action.employeeScheduleBeforeRecoveringAction, myScheduleParameters);
        } else if (action.getClass().getName() == "RecoveringActionFullTimeEmployee") {
            actionCost = getFullTimeEmployeeCost(action.employeeScheduleAfterRecoveringAction, myScheduleParameters) - 
                    getFullTimeEmployeeCost(action.employeeScheduleBeforeRecoveringAction, myScheduleParameters);
        }
        return actionCost;
    }
    
    public static int getPartTimeEmployeeCost( boolean[] employeeSchedule, ParametersInitialSchedules myScheduleParameters) {
        
        int consecutiveWorkingPeriods = 0;
        int overtimeWorkingPeriods = 0;
        int totalWorkingPeriods = 0;
        for (int workPeriod = 0; workPeriod < employeeSchedule.length ; workPeriod++) {
            if (employeeSchedule[workPeriod]) {
                totalWorkingPeriods += 1;
                consecutiveWorkingPeriods += 1;
                if (consecutiveWorkingPeriods > myScheduleParameters.getWorkingPeriodsPaidAtRegularHourlyRatePerShiftWork()) {
                    overtimeWorkingPeriods += 1;
                }
            } else {
                consecutiveWorkingPeriods = 0;
            }
        }
        
        int additionalOvertimeWorkingPeriods = totalWorkingPeriods - myScheduleParameters.getWorkingPeriodsPaidAtRegularHourlyRatePerSchedule();
        if ( additionalOvertimeWorkingPeriods > 0 ){
            overtimeWorkingPeriods += additionalOvertimeWorkingPeriods;
        }
        
        int employeeCost = myScheduleParameters.fixedCostOfPartTimeEmployeesPerSchedule + 
                overtimeWorkingPeriods * myScheduleParameters.getWorkingPeriodCostOfPartTimeEmployeesPaidAtOvertimeHourlyRate() +
                (totalWorkingPeriods - overtimeWorkingPeriods) * myScheduleParameters.getWorkingPeriodCostOfPartTimeEmployeesPaidAtRegularHourlyRate();
        
        return employeeCost;
    }
    
    public static int getFullTimeEmployeeCost( boolean[] employeeSchedule, ParametersInitialSchedules myScheduleParameters) {
       
        int consecutiveWorkingPeriods = 0;
        int overtimeWorkingPeriods = 0;
        int totalWorkingPeriods = 0;
        for (int workPeriod = 0; workPeriod < employeeSchedule.length ; workPeriod++) {
            if (employeeSchedule[workPeriod]) {
                totalWorkingPeriods += 1;
                consecutiveWorkingPeriods += 1;
                if (consecutiveWorkingPeriods > myScheduleParameters.getWorkingPeriodsPaidAtRegularHourlyRatePerShiftWork()) {
                    overtimeWorkingPeriods += 1;
                }
            } else {
                consecutiveWorkingPeriods = 0;
            }
        }
        
        int additionalOvertimeWorkingPeriods = totalWorkingPeriods - myScheduleParameters.getWorkingPeriodsPaidAtRegularHourlyRatePerSchedule();
        if ( additionalOvertimeWorkingPeriods > 0 ){
            overtimeWorkingPeriods += additionalOvertimeWorkingPeriods;
        }
        
        int employeeCost = myScheduleParameters.fixedCostOfFullTimeEmployeesPerSchedule + 
                overtimeWorkingPeriods * myScheduleParameters.getWorkingPeriodCostOfFullTimeEmployeesPaidAtOvertimeHourlyRate() +
                (totalWorkingPeriods - overtimeWorkingPeriods) * myScheduleParameters.getWorkingPeriodCostOfFullTimeEmployeesPaidAtRegularHourlyRate();
        
        return employeeCost;
    }
}
